---
title: PromiseRejectionEvent
slug: Web/API/PromiseRejectionEvent
tags:
  - API
  - HTML DOM
  - Interface
  - JavaScript
  - PromiseRejectionEvent
  - Promises
  - Reference
  - events
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong><code>PromiseRejectionEvent</code></strong> interface represents events which are sent to the global script context when JavaScript {{jsxref("Promise")}}s are rejected.</span> These events are particularly useful for telemetry and debugging purposes.</p>

<p>For details on promise rejection events, see {{SectionOnPage("/en-US/docs/Web/JavaScript/Guide/Using_promises", "Promise rejection events")}}.</p>

<p>{{InheritanceDiagram(600, 120)}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("PromiseRejectionEvent.PromiseRejectionEvent", "PromiseRejectionEvent()")}}</dt>
 <dd>Creates a <code>PromiseRejectionEvent</code> event, given the type of event (<code><a href="/en-US/docs/Web/API/Window/unhandledrejection_event">unhandledrejection</a></code> or <code><a href="/en-US/docs/Web/API/Window/rejectionhandled_event">rejectionhandled</a></code>) and other details.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Also inherits properties from its parent {{domxref("Event")}}</em>.</p>

<dl>
 <dt>{{domxref("PromiseRejectionEvent.promise")}} {{readonlyInline}}</dt>
 <dd>The JavaScript {{jsxref("Promise")}} that was rejected.</dd>
 <dt>{{domxref("PromiseRejectionEvent.reason")}} {{readOnlyInline}}</dt>
 <dd>A value or {{jsxref("Object")}} indicating why the promise was rejected, as passed to {{jsxref("Promise.reject()")}}.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface has no unique methods; inherits methods from its parent {{domxref("Event")}}</em>.</p>

<h2 id="Events">Events</h2>

<dl>
 <dt>{{Event("rejectionhandled")}}</dt>
 <dd>Fired when a JavaScript {{jsxref("Promise")}} is rejected, and after the rejection is handled by the promise's rejection handling code.</dd>
 <dt>{{Event("unhandledrejection")}}</dt>
 <dd>Fired when a JavaScript {{jsxref("Promise")}} is rejected but there is no rejection handler to deal with the rejection.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>This simple example catches unhandled promise rejections and logs them for debugging purposes.</p>

<pre class="brush: js">window.onunhandledrejection = function(e) {
  console.log(e.reason);
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'webappapis.html#promiserejectionevent', 'PromiseRejectionEvent')}}</td>
   <td>{{ Spec2('HTML WHATWG') }}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PromiseRejectionEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Archive/Add-ons/Techniques/Promises">Promises</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Using_promises">Using promises</a></li>
 <li>{{jsxref("Promise")}}</li>
 <li>{{domxref("WindowEventHandlers.onrejectionhandled")}}</li>
 <li>{{domxref("WindowEventHandlers.onunhandledrejection")}}</li>
</ul>
